<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>StatusOK</title>

    <style>
        html, body {
            font-family: sans-serif;
            box-sizing: border-box;
            padding: 0;
            margin: 0;
        }

        h1 {
            margin: 40px 0;
        }

        a, a:visited {
            color: #3498db;
        }

        a:hover {
            color: #85c1e9;
        }

        .site {
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
        }

        .creds {
            margin: 40px 0;
        }

        table {
            border-collapse: collapse;
        }

        thead {
            text-transform: uppercase;
        }

        thead, tbody .status {
            font-weight: bold;
        }

        td {
            padding: 9px 14px;
        }

        td.status {
            color: #e74c3c;
        }

        td.status.ok {
            color: #2ecc71;
        }

        .error {
            padding: 0;
            margin: 40px 0 0;
            color: #e74c3c;
            text-align: center;
        }
    </style>
</head>
<body>
<div class="site">
    <h1>StatusOK</h1>
    <div id="app">
        <table>
            <thead>
            <tr>
                <td>URL</td>
                <td>Status</td>
                <td>Response Time</td>
                <td>Changed</td>
                <td>Updated</td>
            </tr>
            </thead>
            <tbody>
            <tr v-for="(status, host) in hosts">
                <td><a :href="host" target="_blank">{{`{{ host }}`}}</a></td>
                <td class="status" :class="{ok: status.is_alive}">{{`{{ status.text }}`}}</td>
                <td>{{`{{ status.duration }}`}}ms</td>
                <td>{{`{{ status.changed_at | moment }}`}} ago</td>
                <td>{{`{{ status.updated_at | moment }}`}} ago</td>
            </tr>
            </tbody>
        </table>
        <p class="error" v-if="error">ERROR: {{`{{ error }}`}} <button @click="initSSE" :disabled="isDisabled">Reconnect</button></p>
    </div>
    <div class="creds">by <a href="https://shub.in" target="_blank">shub.in</a></div>
</div>
<script src="https://cdn.jsdelivr.net/npm/vue@2"></script>
<script src="https://momentjs.com/downloads/moment.min.js"></script>
<script>
    var app = new Vue({
        el: '#app',
        data() {
            return {
                hosts: {},
                error: null,
                es: null,
                isDisabled: false,
            }
        },
        methods: {
            async getStat() {
                const resp = await fetch('{{ .Prefix }}/stat')
                this.hosts = await resp.json()
            },
            initSSE() {
                console.log('Init SSE')
                this.isDisabled = true
                this.es = new EventSource('{{ .Prefix }}/sse')
                this.es.onmessage = this.onmessage
                this.es.onopen = this.onopen
                this.es.onerror = this.onerror
                this.es.addEventListener('close', this.onclose)
            },
            onmessage(event) {
                this.hosts = JSON.parse(event.data)
            },
            onclose(event) {
                this.error = "Connection was closed by server"
                this.es.close()
                this.isDisabled = false
            },
            onopen() {
                this.error = null
                this.isDisabled = false
            },
            onerror() {
                this.error = `Can’t establish a connection to the server`
                this.isDisabled = false
            }
        },
        filters: {
            moment(date) {
                return moment(date).toNow(true)
            }
        },
        mounted() {
            this.getStat()
            this.initSSE()
        }
    })
</script>
</body>
</html>